/**
 *	@file test2.cpp
 *	@brief	\ł̕񏈗̎Ԍv.
 */

#include <stddef.h>
#include <cstddef>
#include <stdlib.h>

#ifdef MALLOC_CHK
#include "malloc_chk.h"
#endif

#include <stdio.h>
#include <assert.h>
#include <string.h>
#include <sstream>
#include <streambuf>
#include <string>

#ifdef _WIN32
#include <windows.h>
#ifdef USE_WTL
#include <atlbase.h>
#include <atlapp.h>
#include <atlmisc.h>
using namespace WTL;
#endif
#endif

#include "StrzStream.h"

using namespace std;


// ===========================================================================

// Ԍv֌W
#ifdef _WIN32
#include <windows.h>
typedef unsigned __int64 	PerfCnt_tick_t;
PerfCnt_tick_t PerfCnt_getTick()	{ PerfCnt_tick_t c; QueryPerformanceCounter((LARGE_INTEGER*)&c); return c; }
PerfCnt_tick_t PerfCnt_tickPerSec() { static PerfCnt_tick_t s = 0; if (!s) QueryPerformanceFrequency((LARGE_INTEGER*)&s); return s;  }
#elif defined LINUX
#include <sys/resource.h>
typedef  double PerfCnt_tick_t;
PerfCnt_tick_t 	PerfCnt_getTick() { struct rusage t; getrusage(RUSAGE_SELF, &t); return t.ru_utime.tv_sec * 1000000.0 + t.ru_utime.tv_usec; }
#define 		PerfCnt_tickPerSec() 	1000000.0
#else
#include <time.h>
typedef clock_t 				PerfCnt_tick_t;
#define PerfCnt_getTick() 		clock()
#define PerfCnt_tickPerSec() 	CLOCKS_PER_SEC
#endif




// ===========================================================================

void dummy_puts(const char* msg);		// ֐œKȂ߁Aʃt@C.
void dummy_puts_set_mode(int mode);


// sprintfgꍇ.
void test_sprintf(const char* fname, unsigned line, double d1, char ch1, const char* msg) {
	char buf[1024];
	sprintf(buf, "%s(%d) : test (%7.5f,%7.5f)%c %s", fname, line, d1, d1, ch1, msg);
	dummy_puts(buf);
}



static CharAryStream<1024>	s_charAryStream;

// Œobt@݂̂stream
void test_chararystream(const char* fname, unsigned line, double d1, char ch1, const char* msg) {
	s_charAryStream.clear_buf();
	s_charAryStream << fname << '(' << line << ") : test (" << d1 << ',' << d1 << ')' << ch1 << ' ' << msg;
	dummy_puts( s_charAryStream.c_str() );
}



static stringstream s_stringstream;

// stringstream \ߐĎgꍇ.
void test_stringstream(const char* fname, unsigned line, double d1, char ch1, const char* msg) {
	s_stringstream.str(std::string(""));
	s_stringstream << fname << '(' << line << ") : test (" << d1 << ',' << d1 << ')' << ch1 << ' ' << msg;
	dummy_puts( s_stringstream.str().c_str() );
}



// ===========================================================================
// v`FbN

typedef void (*test_print_func_t)(const char* fname, unsigned line, double d1, char ch1, const char* msg);


double test(test_print_func_t test_print, size_t size, unsigned flags, const char* ttl) {
	unsigned char	verboss		= flags & 1;
	if (verboss) {
		fprintf(stderr, "\t%s:start\n", ttl);
		dummy_puts_set_mode(verboss);
		//size = 1;
	  #ifdef MALLOC_CHK
		my_malloc_count_init();
	  #endif
	}
	// _~[\=񏈗 ̌v.
	PerfCnt_tick_t	start_time	= PerfCnt_getTick();				// vJn
	for (unsigned j = 0; j < size; ++j) {
		test_print(__FILE__, 1234/*__LINE__*/, 3.1415926, '>', "dummy message\n" );
	}
	PerfCnt_tick_t elapsed	  = PerfCnt_getTick() - start_time;		// vI

	double e = elapsed * 1.0 / (PerfCnt_tickPerSec() * size);
	if (verboss) {
		fprintf(stderr, "\t%s:end (%f)\n", ttl, e * 1000000.0);
	  #ifdef MALLOC_CHK
		my_malloc_count_disp();
	  #endif
	}
	return e;	// \[g.
}



void test_all(unsigned size, unsigned v) {
	const char*	nm[32]	   = {0};
	double		elaped[32] = { 0 };
	fprintf(stderr, "\n_~[bZ[W̕񏈗Ԃ̌v\n" );
	if (v)
		fprintf(stderr, "o͉ %9d (̕)\n", size);

	// e\[g̃`FbN.
	unsigned k 	   = 0;
	{
		nm[k] = "sprintf      "	; elaped[k] = test(test_sprintf 	 , size, v, nm[k]); ++k;
		nm[k] = "CharAryStream"	; elaped[k] = test(test_chararystream, size, v, nm[k]); ++k;
		nm[k] = "stringstream "	; elaped[k] = test(test_stringstream , size, v, nm[k]); ++k;
	}

	// sʂ̏o
	printf("\n*** _~[bZ[W%d̕ς̕񏈗(ʕb)\n", size);
	printf("\n");
	for (unsigned j = 0; j < 32; ++j) {
		if (nm[j] == 0)
			continue;
		printf(",%-21s ,", nm[j]);
		double e = elaped[j]*1000000.0;
		if (e > 0)
			printf("%12.3f,", e);
		else
			printf("%12s,", "---");
		printf("\n");
	}
}


int main(int argc, char* argv[]) {
	unsigned 	size 	   = 1;	//100000;
	unsigned 	v	  	   = 0;

	// IvV`FbN
	for (int i = 1; i < argc; ++i) {
		if (strncmp(argv[i], "-c",2) == 0) {	// [v.
			size			= strtol(argv[i]+2,0,0);
			if (size < 1)
				size = 1;
		} else if (strcmp(argv[i], "-v") == 0) {
			v = 1;
		}
	}

	test_all(size, v);

	return 0;
}
